<?php

class Class_Pi_Edd_Message{

    public $plugin_name;

    private $setting = array();

    private $active_tab;

    private $this_tab = 'message';

    private $tab_name = "Advance setting";

    private $setting_key = 'message_settting';

    

    private $product_location = array('woocommerce_before_add_to_cart_button'=>'Before add to cart button', 'woocommerce_after_add_to_cart_button'=>'After add to cart button',
    'woocommerce_before_add_to_cart_form'=>'Before add to cart form',
    'woocommerce_after_add_to_cart_form'=>'After add to cart form', 
    );
    private $category_location = array('woocommerce_after_shop_loop_item_title'=>'After title', 'woocommerce_shop_loop_item_title'=>'After Image', 'woocommerce_after_shop_loop_item'=>'After price');



    function __construct($plugin_name){
      

        $this->plugin_name = $plugin_name;
        
        $this->active_tab = (isset($_GET['tab'])) ? sanitize_text_field($_GET['tab']) : 'default';

        if($this->this_tab == $this->active_tab){
            add_action($this->plugin_name.'_tab_content', array($this,'tab_content'));
        }

        add_action($this->plugin_name.'_tab', array($this,'tab'),2);

        add_action('woocommerce_init', array($this,'shipping_zone_to_array'));
        
        
    }

    function shipping_zone_to_array(){
      
        
        
        $this->settings = array(
            array('field'=>'title', 'class'=> 'bg-primary text-light', 'class_title'=>'text-light font-weight-light h4', 'label'=>"Single product page setting", 'type'=>"setting_category"),
            array('field'=>'pi_show_product_page', 'label'=>__('Show estimate on single product page','pi-edd'),'type'=>'switch', 'default'=>1,   'desc'=>'Show estimate date on product page'),
            
            array('field'=>'pi_product_page_text', 'label'=>__('Estimated date, Wording on product page','pi-edd'),'type'=>'text', 'default'=>'Estimated delivery date {date}',  'desc'=>'This will be shown besides the estimated date on single product page, PRO version allows you to show more custom message using short code {date}, {days} to show estimate as number of days count'),
            array('field'=>'pi_product_page_text_range', 'label'=>__('Estimated date, Wording on product page, for date range','pi-edd'),'type'=>'text', 'default'=>'Estimated delivery between {min_date} - {max_date}',  'desc'=>'This will be shown besides the estimated date range on single product page when showing date range, PRO version allows you to show more custom message using short code {min_date}, {max_date}, {min_days} or {max_days} as estimate in terms of days count '),
            array('field'=>'pi_product_page_position', 'label'=>__('Position on single product page','pi-edd'),'type'=>'select', 'default'=>'woocommerce_before_add_to_cart_button',   'desc'=>'Estimate position on single product page', 'value'=>$this->product_location),
            
            array('field'=>'title', 'class'=> 'bg-primary text-light', 'class_title'=>'text-light font-weight-light h4', 'label'=>"Shop / Category page setting", 'type'=>"setting_category"),
            array('field'=>'pi_show_product_loop_page', 'label'=>__('Show estimate on product loop page','pi-edd'),'type'=>'switch', 'default'=>1,  'desc'=>'Show estimate date on shop page or product category page'),
            
            array('field'=>'pi_loop_page_text', 'label'=>__('Estimated date, Wording on category / shop page','pi-edd'),'type'=>'text', 'default'=>'Estimated delivery date {date} ',  'desc'=>'This will be shown besides the estimated date on category or shop page, PRO version allows you to show more custom message using short code {date}, {days} to show estimate as number of days count'),
            array('field'=>'pi_loop_page_text_range', 'label'=>__('Estimated date, Wording on category / shop page, for date range','pi-edd'),'type'=>'text', 'default'=>'Estimated delivery between {min_date} - {max_date}',  'desc'=>'This will be shown besides the estimated date range on category or shop page when showing date range, PRO version allows you to show more custom message using short code {min_date}, {max_date},  {min_days} or {max_days} as estimate in terms of days count'),
            array('field'=>'pi_loop_page_position', 'label'=>__('Position on category / shop page','pi-edd'),'type'=>'select', 'default'=>'woocommerce_after_shop_loop_item_title',   'desc'=>'Estimate position on single product page', 'value'=>$this->category_location),

            array('field'=>'title', 'class'=> 'bg-primary text-light', 'class_title'=>'text-light font-weight-light h4', 'label'=>"Cart / Checkout page setting", 'type'=>"setting_category"),
            array('field'=>'pi_show_cart_page', 'label'=>__('Show estimate on cart page for each product','pi-edd'),'type'=>'switch', 'default'=>1,   'desc'=>'Show estimate date on cart page for each product'),
            array('field'=>'pi_show_checkout_page', 'label'=>__('Show estimate on checkout page for each product','pi-edd'),'type'=>'switch', 'default'=>1,   'desc'=>'Show estimate date on checkout page for each product'),
           
            
            
            
           

            
            array('field'=>'pi_edd_cart_page_show_overall_estimate', 'label'=>__('Show estimate for complete order on checkout page','pi-edd'),'type'=>'switch', 'default'=>1,   'desc'=>'When you enable this it will show the estimate time for the complete cart, (it takes estimate of all the product in cart and show the largest date as the estimate,<strong>if estimate date of Product A = March 5, Product B = March 7 the the estimate of complete cart will be March 7</strong>)'),

            array('field'=>'pi_edd_show_overall_estimate_on_cart_page', 'label'=>__('Show estimate for complete order on cart page','pi-edd'),'type'=>'switch', 'default'=>1,   'desc'=>'When you enable this it will show the estimate time for the complete cart, (it takes estimate of all the product in cart and show the largest date as the estimate,<strong>if estimate date of Product A = March 5, Product B = March 7 the the estimate of complete cart will be March 7</strong>)'),
            
            array('field'=>'pi_cart_page_text', 'label'=>__('Estimated date, Wording on cart / checkout page','pi-edd'),'type'=>'text', 'default'=>'Estimated delivery date {date}',  'desc'=>'This will be shown besides the estimated date on cart or checkout page, PRO version allows you to show more custom message using short code {date}, {days} to show estimate as number of days count'),
            array('field'=>'pi_cart_page_text_range', 'label'=>__('Estimated date, Wording on cart / checkout page, for date range','pi-edd'),'type'=>'text', 'default'=>'Estimated delivery between {min_date} - {max_date}',  'desc'=>'This will be shown besides the estimated date range on cart or checkout page when showing date range, PRO version allows you to show more custom message using short code {min_date}, {max_date}, {min_days} or {max_days} as estimate in terms of days count'),

            array('field'=>'title', 'class'=> 'bg-primary text-light', 'class_title'=>'text-light font-weight-light h4', 'label'=>"Order detail and Order email", 'type'=>"setting_category"),

            array('field'=>'pi_edd_cart_page_show_single_estimate', 'label'=>__('Add estimate date for each product in stored order and email','pi-edd'),'type'=>'switch', 'default'=>0,   'desc'=>'It will add estimate for each product in : order stored in backend, order email send to admin and customer'),
           
            array('field'=>'pi_edd_show_overall_estimate_in_email', 'label'=>__('Show estimate for complete order in order email','pi-edd'),'type'=>'switch', 'default'=>1,   'desc'=>'When you enable this it will show the estimate time for the complete order in order email, (it takes estimate of all the product in cart and show the largest date as the estimate,<strong>if estimate date of Product A = March 5, Product B = March 7 the the estimate of complete cart will be March 7</strong>)'),

            array('field'=>'pi_edd_show_overall_estimate_in_order_success_page', 'label'=>__('Show estimate for complete order in order success page','pi-edd'),'type'=>'switch', 'default'=>1,   'desc'=>'When you enable this it will show the estimate time for the complete order on order success page, (it takes estimate of all the product in cart and show the largest date as the estimate,<strong>if estimate date of Product A = March 5, Product B = March 7 the the estimate of complete cart will be March 7</strong>)'),

            array('field'=>'pi_overall_estimate_text', 'label'=>__('Overall estimate wording','pi-edd'),'type'=>'text', 'default'=>'Order estimated delivery date {date}',  'desc'=>'This will show the overall estimate of the order on checkout page and order email, and stored in the order using short code {date}, {days} to show estimate as number of days count'),

            array('field'=>'pi_overall_estimate_range_text', 'label'=>__('Overall estimate wording for range','pi-edd'),'type'=>'text', 'default'=>'Order estimated delivery between {min_date} - {max_date}',  'desc'=>'This will show the overall estimate of the order on checkout page and order email, and stored in the order, using short code {min_date}, {min_days}, {max_date}, {max_days} to show estimate as number of days count'),
        );
        $this->register_settings();
        
        if(PISOL_EDD_DELETE_SETTING){
            $this->delete_settings();
        }
    }

    
    function delete_settings(){
        foreach($this->settings as $setting){
            delete_option( $setting['field'] );
        }
    }


    function register_settings(){   

        foreach($this->settings as $setting){
            register_setting( $this->setting_key, $setting['field']);
        }
    
    }

    function tab(){
        ?>
        <a class=" px-3 text-light d-flex align-items-center  border-left border-right  <?php echo ($this->active_tab == $this->this_tab ? 'bg-primary' : 'bg-secondary'); ?>" href="<?php echo admin_url( 'admin.php?page='.sanitize_text_field($_GET['page']).'&tab='.$this->this_tab ); ?>">
            <?php _e( $this->tab_name, 'http2-push-content' ); ?> 
        </a>
        <?php
    }

    function tab_content(){
       ?>
        <form method="post" action="options.php"  class="pisol-setting-form">
        <?php settings_fields( $this->setting_key ); ?>
        <?php
            foreach($this->settings as $setting){
                new pisol_class_form_edd($setting, $this->setting_key);
            }
        ?>
        <input type="submit" class="mt-3 btn btn-primary btn-sm" value="Save Option" />
        </form>
       <?php
    }
}

new Class_Pi_Edd_Message($this->plugin_name);
