<?php

class pi_edd_common{

    /* 4/7/19 */
    public static $legacy_methods = array('flat_rate', 'free_shipping', 'local_pickup');

    public static function getMinMax($method, $method_name){
        $min_max = array();
        /** option format is like this woocommerce_free_shipping_23_settings */
            $option_name = "woocommerce_".$method_name."_".$method."_settings";
            $present_setting = get_option($option_name);
            $min_max['min_days'] = isset($present_setting['min_days']) ? $present_setting['min_days'] : 1;
            $min_max['max_days'] = isset($present_setting['max_days']) ? $present_setting['max_days'] : 1;
        return $min_max;
    }

    public static function getMin($method, $method_name){
        $min_days = "";
        /** option format is like this woocommerce_free_shipping_23_settings */
            $option_name = "woocommerce_".$method_name."_".$method."_settings";
            $present_setting = get_option($option_name);
            $min_days = isset($present_setting['min_days']) ? $present_setting['min_days'] : 1;
           
        return $min_days;
    }

    public static function getMax($method, $method_name){
        $max_days = "";
        /** option format is like this woocommerce_free_shipping_23_settings */
            $option_name = "woocommerce_".$method_name."_".$method."_settings";
            $present_setting = get_option($option_name);
            $min_days = isset($present_setting['min_days']) ? $present_setting['min_days'] : 1;

            $max_days = isset($present_setting['max_days']) ? $present_setting['max_days'] : $min_days;
           
        return $max_days;
    }
    /* 4/7/19 */

    public static function getMessage($variable, $default){
        $message = get_option($variable, $default);
        $language_specific_message =  self::getLanguageMessage($variable);
        if($language_specific_message){
            $message = $language_specific_message;
        }
        return $message;
    }

    public static function getLanguageMessage($variable){
        $lang = get_locale();
        $messages = get_option('pi_edd_translate_message',array());
        if(is_array($messages)){
        foreach($messages as $message){
            if($message['language'] == $lang && isset($message[$variable]) && $message[$variable] != "" ){
                return $message[$variable]; 
            }
        }
        }
        return false;
    }

    public static function isDateHoliday($date){
        $holidays = get_option("pi_edd_holidays",false);
        $holidays = explode(":",$holidays);
        if(is_array($holidays)){
            return in_array($date, $holidays) ? true : false;
        }
        return false;
    }

    public static function isSkipDay($date){
        $day = date('N',strtotime($date));
        $skip_days_of_the_week = get_option("pi_days_of_week",array());
        $skip_days_of_the_week = is_array($skip_days_of_the_week) ? $skip_days_of_the_week : array();
        
        if(in_array($day, $skip_days_of_the_week)){
            return true;
        }
        return false;
    }

    public static function formatedDate($date){
        if(empty($date)) return null;
        $date_format =  get_option('pi_general_date_format','Y/m/d');
        return date_i18n($date_format, strtotime($date));
    }
    
}